
; Description ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{1

	; ==========================================================================
	; 
	;	OPRIQ (Qwerty OPtional RIght) keyboard layout for Windows 10.
	; 	// version from 22 Oct 2022
	; 	
	; 	OPRIQ is special keyboard layout that allows you at any moment to type
	; 	either with only left hand of with both hands.
	; 	
	; 	Roman Averyanov
	; 	romanavr.com
	; 
	; 	License: Just pls reference me, lol
	; 	
	; ==========================================================================

	; + This file was written with Tab_Width=4 (one <Tab> symbol should be shows as 4 <Space> symbols)
	; 
	; + In case you wonder, cells outline file structure was created
	;   with my plugin 'VimCells' for Vim (will publish it somewhere later)

; _____________________________________________________________________________/ }}}1

; Initialization ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{1

; ■ AHK Setup ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	; SendMode Input				; -> Can Solve RAlt issue
	#NoEnv							; Recommended for performance and compatibility with future AutoHotkey releases.
	#MaxHotkeysPerInterval 9999

	appSuspendedQ = 0
	splash_size_X = 300
	splash_size_Y = 25
	splash_time   = 1000
	splash_header = OPRIQ Keyboard Layout

; ________________________________________________________________________/ }}}2

; ■ Layering Setup ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	lKey_LT2	 := "Space"
	lKey_LNv	 := "Tab"
	lKey_RNv1	 := "RAlt"
	lKey_RNv2	 := "F14"

	IS_1hMode_disabled := 0
	alarm_Length := -1000
	tap_time_gap := 250
	neg_time_gap := -1*tap_time_gap

	chords_keysTracked := {"CHKEY_S": 0, "CHKEY_D": 0, "CHKEY_F": 0}
	chords_TimeGap := -25			
	chords_gatheringPhaseQ := 0

	grv_Phase := "03 Released"
	is_grvKey_auxShift_pressedQ = 0

	rAlt_Phase := "03 Released"
	rAlt_doublePress_possibleQ := 0
	; also works for F14

; ________________________________________________________________________/ }}}2
; ■ Key names aliases ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	blank	:= ""
	auxMod	:= ""

	NVMODS_ON	:= TRUE
	NVMODS_OFF	:= FALSE
	ALARM2H_ON	:= TRUE
	ALARM2H_OFF := FALSE

	KC_ENT	:= "{Enter}"
	KC_BSPC := "{BS}"
	KC_DEL	:= "{Del}"
	KC_TAB	:= "{Tab}"
	KC_ESC	:= "{Esc}"

	KC_HOME := "{Home}"
	KC_End	:= "{End}"
	KC_DOWN := "{Down}"
	KC_LEFT := "{Left}"
	KC_RGHT := "{Right}"
	KC_UP	:= "{Up}"

	KC_WHUP := "{WheelUp}"
	KC_WHDN := "{WheelDown}"

	KC_VOLU := "{Volume_Up}"
	KC_VOLD := "{Volume_Down}"
	KC_PLAY := "{Media_Play_Pause}"

	KC_APPS := "{AppsKey}"
	KC_PGUP := "{PgUp}"
	KC_PGDN := "{PgDn}"

	KC_F1	:= "{F1}"
	KC_F2	:= "{F2}"
	KC_F3	:= "{F3}"
	KC_F4	:= "{F4}"
	KC_F5	:= "{F5}"
	KC_F6	:= "{F6}"
	KC_F7	:= "{F7}"
	KC_F8	:= "{F8}"
	KC_F9	:= "{F9}"
	KC_F10	:= "{F10}"
	KC_F11	:= "{F11}"
	KC_F12	:= "{F12}"

	KC_1	:= "1"
	KC_2	:= "2"
	KC_3	:= "3"
	KC_4	:= "4"
	KC_5	:= "5"
	KC_6	:= "6"
	KC_7	:= "7"
	KC_8	:= "8"
	KC_9	:= "9"
	KC_0	:= "0"
	KC_MINS := "-"
	KC_EQL	:= "="

	KC_A	:= "{SC01E}"
	KC_B	:= "{SC030}"
	KC_C	:= "{SC02E}"
	KC_D	:= "{SC020}"
	KC_E	:= "{SC012}"
	KC_F	:= "{SC021}"
	KC_G	:= "{SC022}"
	KC_H	:= "{SC023}"
	KC_I	:= "{SC017}"
	KC_J	:= "{SC024}"
	KC_K	:= "{SC025}"
	KC_L	:= "{SC026}"
	KC_M	:= "{SC032}"
	KC_N	:= "{SC031}"
	KC_O	:= "{SC018}"
	KC_P	:= "{SC019}"
	KC_Q	:= "{SC010}"
	KC_R	:= "{SC013}"
	KC_S	:= "{SC01F}"
	KC_T	:= "{SC014}"
	KC_U	:= "{SC016}"
	KC_V	:= "{SC02F}"
	KC_W	:= "{SC011}"
	KC_X	:= "{SC02D}"
	KC_Y	:= "{SC015}"
	KC_Z	:= "{SC02C}"
	KC_COMM := "{SC033}"	; ,
	KC_DOT	:= "{SC034}"	; .
	KC_BSLS := "{SC02B}"	; \
	KC_GRV	:= "{SC029}"	; `
	KC_QUOT := "{SC028}"	; '
	KC_SLSH := "{SC035}"	; /
	KC_SCLN := "{SC027}"	; ;
	KC_LBRC := "{SC01A}"	; [
	KC_RBRC := "{SC01B}"	; ]

; ________________________________________________________________________/ }}}2
; ■ Chording Setup ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	keyS_Func := {1: KC_S, 2: KC_L, 3: KC_LEFT}
	keyD_Func := {1: KC_D, 2: KC_K, 3: KC_DOWN}
	keyF_Func := {1: KC_T, 2: KC_N, 3: KC_RGHT}

; ________________________________________________________________________/ }}}2
; ■ Mouse Setup ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	mKey_Slow	:= "a"
	mKey_Fast	:= "'"
	mKey_Up		:= "e"
	mKey_Down	:= "d"
	mKey_Left	:= "s"
	mKey_Right	:= "f"

	mouse_SpeedX := {"Slow2": 1, "Slow1": 3, "Normal":9, "Fast1":30}
	mouse_SpeedY := {"Slow2": 1, "Slow1": 2, "Normal":7, "Fast1":20}

	SetMouseDelay, -1
	mouse_UpdateInterval := -1
	mouse_MoveX := 0
	mouse_MoveY := 0
	mouse_ChoosedSpeed := "Normal"

; ________________________________________________________________________/ }}}2

; ■ Tray Icon Setup ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	App_Icon = %a_scriptdir%\OPRIQ.png

	IfExist, %App_Icon%
		Menu, Tray, Icon, %App_Icon%
	Return

; ________________________________________________________________________/ }}}2
; ■ Lang Setup ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	SetWindowsLayout(0x0409)	; Set to US to prevent "no hotkey in current layout" message when AHK loads

; ________________________________________________________________________/ }}}2

; _____________________________________________________________________________/ }}}1

; Functions ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{1

; ■ App Controls ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

; ■ ■ unpressAllMods() ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{3

	unpressAllMods() 
	{
	global

		Send, {Shift up}
		Send, {LShift up}
		Send, {RShift up}

		Send, {Alt up}
		Send, {LAlt up}
		Send, {RAlt up}

		Send, {Ctrl up}
		Send, {LCtrl up}
		Send, {RCtrl up}

		Send, {LButton up}
		Send, {RButton up}
		Send, {MButton up}

		Send, {Win up}
		Send, {LWin up}
		Send, {RWin up}

		SplashTextOn, splash_size_X, splash_size_Y, %splash_header%, Mod keys were unpressed
		Sleep, splash_time
		SplashTextOff

	Return
	}

; ___________________________________________________________________/ }}}3
; ■ ■ reloadApp() ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{3

	reloadApp() {
	global

		SetWindowsLayout(0x0409)

		SplashTextOn, splash_size_X, splash_size_Y, %splash_header%, Reloaded
		Sleep, splash_time
		SplashTextOff

		Reload

	Return

	}

; ___________________________________________________________________/ }}}3
; ■ ■ showSuspendPrompt() ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{3

	showSuspendPrompt() {
	global
		if (appSuspendedQ=0)
		{
			SplashTextOn, splash_size_X, splash_size_Y, %splash_header%, Suspended
			Sleep, splash_time
			SplashTextOff
			appSuspendedQ = 1
		}
		else
		{

			SplashTextOn, splash_size_X, splash_size_Y, %splash_header%, Activated
			Sleep, splash_time
			SplashTextOff
			appSuspendedQ = 0
		}
	Return
	}

; ___________________________________________________________________/ }}}3

; ________________________________________________________________________/ }}}2
; ■ sendKey depending on Layer ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	sendKey_dependingOnLayer(kHm, kT2, kNv, directiveToCall2hAlarm := false, directiveToCallNvSymbWithMods := false)
	{

		If (directiveToCall2hAlarm) {
			trigger_2hAlarm()
		}
	
		Switch get_ActiveLayer() {

			case "Hm"	: stringToSend := kHm
			case "T2"	: stringToSend := kT2
			case "A2"	: stringToSend := "{LAlt Down}" . kT2 . "{LAlt Up}"
			case "Nv"	: stringToSend := (directiveToCallNvSymbWithMods) ? send_SymbWithMods(kNv) : kNv 

			case "NotInList" : stringToSend := ""
			default			 : stringToSend := ""

		}

		Send, {Blind}%stringToSend%

		Return
	}

; ________________________________________________________________________/ }}}2
; ■ get_ActiveLayer() ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	get_ActiveLayer() {
		global

		check_No1 := (IS_1hMode_disabled=1)		   ? "No1_" : ""
		check_LT2 := (GetKeyState(lKey_LT2,"P")=1) ? "LT2_" : ""
		check_LNv := (GetKeyState(lKey_LNv,"P")=1) ? "LNv_" : ""
		check_RNv := (rAlt_Phase="01 Single Hold") ? "RNv_" : ""
		check_RMs := (rAlt_Phase="02 Double Hold") ? "RMs_" : ""

		lMask	  := check_No1 . check_LT2 . check_LNv . check_RNv . check_RMs

		Switch lMask {

			case "":				lToOpen := "Hm"
			case "No1_":			lToOpen := "Hm"

			case "LT2_":			lToOpen := "T2"
			case "No1_LT2_":		lToOpen := "Hm"

			case "LNv_":			lToOpen := "Nv"
			case "No1_LNv_":		lToOpen := "Hm"

			case "RNv_":			lToOpen := "Nv"
			case "No1_RNv_":		lToOpen := "Nv"

			case "RMs_":			lToOpen := "Ms" ; not used
			case "No1_RMs_":		lToOpen := "Ms" ; not used

			case "LT2_LNv_":		lToOpen := "A2" ; Alt Text2
			case "No1_LT2_LNv_":	lToOpen := "Hm"

			default:				lToOpen := "NotInList"

		}

		Return, lToOpen

	}

; ________________________________________________________________________/ }}}2
; ■ 2h alarm code ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	trigger_2hAlarm() {
		global
		
		IS_1hMode_disabled := 1
		SetTimer, timer_2hAlarm, %alarm_Length%

		Return
	}

	timer_2hAlarm:

		IS_1hMode_disabled := 0

	Return

; ________________________________________________________________________/ }}}2
; ■ Chords ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	register_chordKey(chKey, kHm, kT2, kNv, directiveToCall2hAlarm := false, directiveToCallNvSymbWithMods := false) {
		global

		If (IS_1hMode_disabled=1 or get_ActiveLayer()="Nv") {

			sendKey_dependingOnLayer(kHm, kT2, kNv, directiveToCall2hAlarm, directiveToCallNvSymbWithMods)	; that is: no chording in no-1h mode, and also in Nv layer

		} else {

			If (chords_gatheringPhaseQ = 0)
			
			{
				SetTimer, chords_Timer, %chords_TimeGap%
				chords_gatheringPhaseQ := 1
			}

			chords_keysTracked[chKey] := 1

		}

		Return
	}

	chords_Timer:

		chord_KeysMask := chords_keysTracked["CHKEY_S"] . chords_keysTracked["CHKEY_D"] . chords_keysTracked["CHKEY_F"]

		Switch chord_KeysMask
		{

			Case, 100: sendKey_dependingOnLayer(keyS_Func[1], keyS_Func[2], cannot_be_used)
			Case, 010: sendKey_dependingOnLayer(keyD_Func[1], keyD_Func[2], cannot_be_used)
			Case, 001: sendKey_dependingOnLayer(keyF_Func[1], keyF_Func[2], cannot_be_used)

			Case, 011: sendKey_dependingOnLayer(KC_ENT , "{Alt Down}{Enter}{Alt Up}"  , cannot_be_used)
			Case, 101: sendKey_dependingOnLayer(KC_DEL , "{LCtrl Down}{Del}{LCtrl Up}", cannot_be_used)
			Case, 110: sendKey_dependingOnLayer(KC_BSPC, "{LCtrl Down}{BS}{LCtrl Up}" , cannot_be_used)

			Case, 111: SwitchLanguage()

		}

		chords_gatheringPhaseQ := 0
		chords_keysTracked := {"CHKEY_S": 0, "CHKEY_D": 0, "CHKEY_F": 0}

	Return

; ________________________________________________________________________/ }}}2
; ■ Send Symbols with Additional Mods ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	send_SymbWithMods(symb) ; Actually any symbol can be send, not just an arrow
	{

		mod_Shift := (GetKeyState("k","P")=1 or GetKeyState("1","P")=1) ? "+"	: ""
		mod_Ctrl  := (GetKeyState("l","P")=1 or GetKeyState("2","P")=1) ? "^"	: ""
		mod_Alt   := (GetKeyState(";","P")=1) ? "!" : ""
		mod_Win   := (GetKeyState("m","P")=1) ? "#" : ""

		mod_x5	  := (GetKeyState("'","P")=1 or GetKeyState("3","P")=1) ?  5	: 1

		mods_Mask := mod_Shift . mod_Ctrl . mod_Alt . mod_Win
		keys_To_Send := mods_Mask . symb
		
		Loop, %mod_x5%
		{
			Send, {Blind}%keys_To_Send%
		}

		Return
	}

; ________________________________________________________________________/ }}}2
; ■ Lang switch ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	SwitchLanguage() {
		Send, {LAlt Down}{LShift Down}{LAlt Up}{LShift Up}

		ToolTip, Lang Switched
		SetTimer, timer_removeTooltip, -500
		return

		Return
	}

	timer_removeTooltip:
		ToolTip
	return

	SetWindowsLayout(LocaleID) {

		Static SPI_SETDEFAULTINPUTLANG := 0x005A, SPIF_SENDWININICHANGE := 2

		Lan := DllCall("LoadKeyboardLayout", "Str", Format("{:08x}", LocaleID), "UINT", 1)
		VarSetCapacity(binaryLocaleID, 4, 0)
		NumPut(LocaleID, binaryLocaleID)
		DllCall("SystemParametersInfo", "UInt", SPI_SETDEFAULTINPUTLANG, "UInt", 0, "UPtr", &binaryLocaleID, "UInt", SPIF_SENDWININICHANGE)

		WinGet, windows, List
		Loop % windows {
			PostMessage 0x50, 0, % Lan, , % "ahk_id " windows%A_Index%
		}

	}

; ________________________________________________________________________/ }}}2

; _____________________________________________________________________________/ }}}1
; Hotkeys ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{1

; ■ General ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	F13::Tab			; Present only on OPRIQ_KB LeftHalf
	F15::Space			; Present only on OPRIQ_KB RightHalf
	CapsLock::LCtrl

	;----------------------------

	*#$F3::reloadApp()

	*#$F4::
		Suspend
		showSuspendPrompt()
	Return

	*#$F5::unpressAllMods()
	*$Pause::unpressAllMods()

	*$AppsKey::
		trigger_2hAlarm()
		SwitchLanguage()
	Return 

    *$Space:: 
		If (IS_1hMode_disabled = 1) {
			Send, {Blind}{Space}
		} else {
			KeyWait, Space
			if(A_PriorKey<>"Space" or A_TimeSinceThisHotkey > tap_time_gap)
			{
				Return
			}
			else {
				Send,{Blind}{Space}
			}
		}
	Return	

; ■ ■ RAlt and F14: Differentiating RNav and Mouse layers ‾‾‾‾‾‾‾‾‾‾‾\ {{{3

	*$RAlt::
		If ((rAlt_Phase = "03 Released") and (rAlt_doublePress_possibleQ = 0)) {

			SetTimer, timer_RAlt, %neg_time_gap%
			rAlt_Phase := "01 Single Hold"
			rAlt_doublePress_possibleQ := 1

		} else if ((rAlt_Phase = "03 Released") and (rAlt_doublePress_possibleQ = 1)) {

			rAlt_Phase := "02 Double Hold"

		}
	Return

	*$RAlt Up::
		rAlt_Phase := "03 Released"
	Return
	
	timer_RAlt:
	{
		rAlt_doublePress_possibleQ := 0
	}
	Return
	
	; ----------------------------------

	*$F14::
		If ((rAlt_Phase = "03 Released") and (rAlt_doublePress_possibleQ = 0)) {

			SetTimer, timer_F14, %neg_time_gap%
			rAlt_Phase := "01 Single Hold"
			rAlt_doublePress_possibleQ := 1

		} else if ((rAlt_Phase = "03 Released") and (rAlt_doublePress_possibleQ = 1)) {

			rAlt_Phase := "02 Double Hold"

		}
	Return

	*$F14 Up::
		rAlt_Phase := "03 Released"
	Return
	
	timer_F14:
	{
		rAlt_doublePress_possibleQ := 0
	}
	Return


; ___________________________________________________________________/ }}}3

; ________________________________________________________________________/ }}}2

; ■ Row: FF ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

   *$F1::sendKey_dependingOnLayer(KC_F1  , KC_F5  , KC_F9  , ALARM2H_OFF, NVMODS_ON  )
   *$F2::sendKey_dependingOnLayer(KC_F2  , KC_F6  , KC_F10 , ALARM2H_OFF, NVMODS_ON  )
   *$F3::sendKey_dependingOnLayer(KC_F3  , KC_F7  , KC_F11 , ALARM2H_OFF, NVMODS_ON  )
   *$F4::sendKey_dependingOnLayer(KC_F4  , KC_F8  , KC_F12 , ALARM2H_OFF, NVMODS_ON  )
   ; F5
   ; F6
   ; F7
   ; F8
   ; F9
   ; F10
   ; F11
   ; F12

; ________________________________________________________________________/ }}}2
; ■ Row: 12345 ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

; ■ ■ Tilda (grv) key ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{3

	*$`:: 
		If (IS_1hMode_disabled = 1) {
			Send, {Blind}%KC_GRV%
		} else {
			is_grvKey_auxShift_pressedQ = 1
			Send {LShift Down}

			If (grv_Phase = "03 Released") {
				SetTimer, timer_GRV, %neg_time_gap%
				grv_Phase := "01 Pressed, Timer ON"
			}

		}
	Return
	
	*$` Up::

		If (is_grvKey_auxShift_pressedQ = 1) {
			Send {LShift Up}
			is_grvKey_auxShift_pressedQ = 0
		}

		If (IS_1hMode_disabled = 0) {
			
			if((grv_Phase = "01 Pressed, Timer ON") and (A_PriorKey="``"))
			{
				actL := get_ActiveLayer()
				Switch actL
				{
					Case, "Hm": Send, {Blind}%KC_GRV%
					Case, "T2": Send, {Blind}%KC_DOT%
				}
			}
			grv_Phase := "03 Released"
		}

	Return
	
	timer_GRV:
	{
		If (grv_Phase = "01 Pressed, Timer ON") {
			grv_Phase := "02 Pressed, Timer OFF"
		}
	}
	Return

; ___________________________________________________________________/ }}}3

	*$1::sendKey_dependingOnLayer(KC_1	 , KC_6   , auxMod )
	*$2::sendKey_dependingOnLayer(KC_2	 , KC_7   , auxMod )
	*$3::sendKey_dependingOnLayer(KC_3	 , KC_8   , auxMod )
	*$4::sendKey_dependingOnLayer(KC_4	 , KC_9   , KC_VOLD)
	*$5::sendKey_dependingOnLayer(KC_5	 , KC_0   , KC_VOLU)
	*$6::sendKey_dependingOnLayer(KC_EQL , KC_MINS, KC_PLAY)
														   
	*$7::sendKey_dependingOnLayer(KC_6	 , blank  , blank  , ALARM2H_ON)
	*$8::sendKey_dependingOnLayer(KC_7	 , blank  , "{U+20BD}"  , ALARM2H_ON)
	*$9::sendKey_dependingOnLayer(KC_8	 , blank  , blank  , ALARM2H_ON)
	*$0::sendKey_dependingOnLayer(KC_9	 , blank  , blank  , ALARM2H_ON)
	*$-::sendKey_dependingOnLayer(KC_0	 , blank  , "{U+00b0}"  , ALARM2H_ON)
	*$=::sendKey_dependingOnLayer(KC_MINS, blank  , "{U+2014}", ALARM2H_ON)
   *$BS::sendKey_dependingOnLayer(KC_BSPC, blank  , blank  , ALARM2H_ON)

; ________________________________________________________________________/ }}}2
; ■ Row: QWERTY ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

; ■ ■ TAB key ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{3

  *$Tab::  
		if (is_1hmode_disabled = 1) {
			send,{blind}%kc_tab%
		} else {
			KeyWait, Tab
			if(A_PriorKey<>"Tab" or A_TimeSinceThisHotkey > tap_time_gap)
			{
				Return
			}
			else {
				Send,{Blind}%KC_TAB%
			}
		}
	Return	

; ___________________________________________________________________/ }}}3
	
	*$q::sendKey_dependingOnLayer(KC_Q	 , KC_P   , KC_DEL , ALARM2H_OFF, NVMODS_ON  )
	*$w::sendKey_dependingOnLayer(KC_W	 , KC_O   , KC_ENT , ALARM2H_OFF, NVMODS_ON  )
	*$e::sendKey_dependingOnLayer(KC_E	 , KC_I   , KC_UP  , ALARM2H_OFF, NVMODS_ON  )
	*$r::sendKey_dependingOnLayer(KC_R	 , KC_U   , KC_BSPC, ALARM2H_OFF, NVMODS_ON  )
	*$t::sendKey_dependingOnLayer(KC_F	 , KC_Y   , blank)
	*$y::sendKey_dependingOnLayer(KC_BSLS, KC_LBRC, KC_PGUP, ALARM2H_OFF, NVMODS_ON  )

	*$u::sendKey_dependingOnLayer(KC_Y	 , blank  , blank  , ALARM2H_ON)
	*$i::sendKey_dependingOnLayer(KC_U	 , blank  , blank  , ALARM2H_ON)
	*$o::sendKey_dependingOnLayer(KC_I	 , blank  , "{U+00ab}" , ALARM2H_ON)
	*$p::sendKey_dependingOnLayer(KC_O	 , blank  , "{U+00bb}" , ALARM2H_ON)
	*$[::sendKey_dependingOnLayer(KC_P	 , blank  , "{U+2022}" , ALARM2H_ON)
	*$]::sendKey_dependingOnLayer(KC_LBRC, blank  , KC_Esc  , ALARM2H_ON)
	*$\::sendKey_dependingOnLayer(KC_RBRC, blank  , blank  , ALARM2H_ON)


; ________________________________________________________________________/ }}}2
; ■ Row: ASDF ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

		*$a::sendKey_dependingOnLayer(KC_A	 , KC_SCLN, KC_HOME, ALARM2H_OFF, NVMODS_ON  )
		*$s::register_chordKey("CHKEY_S", keyS_Func[1], keyS_Func[2], keyS_Func[3], ALARM2H_OFF, NVMODS_ON	)
		*$d::register_chordKey("CHKEY_D", keyD_Func[1], keyD_Func[2], keyD_Func[3], ALARM2H_OFF, NVMODS_ON	)
		*$f::register_chordKey("CHKEY_F", keyF_Func[1], keyF_Func[2], keyF_Func[3], ALARM2H_OFF, NVMODS_ON	)
		*$g::sendKey_dependingOnLayer(KC_G	 , KC_H   , KC_END , ALARM2H_OFF, NVMODS_ON  )
		*$h::sendKey_dependingOnLayer(KC_QUOT, KC_RBRC, KC_PGDN, ALARM2H_OFF, NVMODS_ON)
													
		*$j::sendKey_dependingOnLayer(KC_H	 , blank  , blank  , ALARM2H_ON)
		*$k::sendKey_dependingOnLayer(KC_N	 , blank  , auxMod , ALARM2H_ON)
		*$l::sendKey_dependingOnLayer(KC_K	 , blank  , auxMod , ALARM2H_ON)
	   *$`;::sendKey_dependingOnLayer(KC_L	 , blank  , auxMod , ALARM2H_ON)
		*$'::sendKey_dependingOnLayer(KC_SCLN, blank  , auxMod , ALARM2H_ON)
	*$Enter::sendKey_dependingOnLayer(KC_ENT , blank  , "{RAlt Down}{Enter}{RAlt Up}"  , ALARM2H_ON)

; ________________________________________________________________________/ }}}2
; ■ Row: ZXCV ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	*$z::sendKey_dependingOnLayer(KC_Z	 , KC_SLSH, KC_APPS)
	*$x::sendKey_dependingOnLayer(KC_X	 , KC_DOT , "{U+2190}"  )
	*$c::sendKey_dependingOnLayer(KC_C	 , KC_COMM, "{U+2193}"  )
	*$v::sendKey_dependingOnLayer(KC_V	 , KC_M   , "{U+2192}"  )
	*$b::sendKey_dependingOnLayer(KC_B	 , KC_J   , "{U+2191}"  )
	
	*$n::sendKey_dependingOnLayer(KC_SLSH, blank  , blank  , ALARM2H_OFF)
	*$m::sendKey_dependingOnLayer(KC_J	 , blank  , auxMod , ALARM2H_ON)
	*$,::sendKey_dependingOnLayer(KC_M	 , blank  , blank  , ALARM2H_ON, NVMODS_ON)
	*$.::sendKey_dependingOnLayer(KC_COMM, blank  , KC_DEL , ALARM2H_ON, NVMODS_ON)
	*$/::sendKey_dependingOnLayer(KC_DOT , blank  , KC_TAB , ALARM2H_ON, NVMODS_ON)

; ________________________________________________________________________/ }}}2

; _____________________________________________________________________________/ }}}1
; Mouse ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{1

; ■ Mouse movement Algorythm ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\ {{{2

	mouse_registerMovementIntention()
	{
		global
		SetTimer, mouse_Timer, %mouse_UpdateInterval%
	}

	mouse_Timer:

		mouse_checkSpeedMod_1 := (GetKeyState(mKey_Slow,"P")) ? 1 : 0
		mouse_checkSpeedMod_2 := (GetKeyState(mKey_Fast,"P")) ? 1 : 0
		mouse_checkSpeed_Mask := mouse_checkSpeedMod_1 . mouse_checkSpeedMod_2

		Switch mouse_checkSpeed_Mask
		{

			Case, 00: mouse_ChoosedSpeed := "Normal"
			Case, 10: mouse_ChoosedSpeed := "Slow1"
			Case, 01: mouse_ChoosedSpeed := "Fast1"
			Case, 11: mouse_ChoosedSpeed := "Slow2"

		}

		mouse_MoveX := 0
		mouse_MoveX := GetKeyState(mKey_Right,"P")
		mouse_MoveX := mouse_MoveX - GetKeyState(mKey_Left,"P")
		mouse_MoveX := mouse_MoveX * mouse_SpeedX[mouse_ChoosedSpeed]

		mouse_MoveY := 0
		mouse_MoveY := GetKeyState(mKey_Down,"P")
		mouse_MoveY := mouse_MoveY - GetKeyState(mKey_Up,"P")
		mouse_MoveY := mouse_MoveY * mouse_SpeedY[mouse_ChoosedSpeed]

		MouseMove, mouse_MoveX, mouse_MoveY, 0, R

		If ((GetKeyState(lKey_RNv1,"P")=1 or GetKeyState(lKey_RNv2,"P")=1) and rAlt_Phase="02 Double Hold")
		{
			SetTimer, mouse_Timer, %mouse_UpdateInterval%
		}

	return

; ________________________________________________________________________/ }}}2

	#if ((GetKeyState(lKey_RNv1,"P")=1 or GetKeyState(lKey_RNv2,"P")=1) and rAlt_Phase="02 Double Hold") 

		*$e::mouse_registerMovementIntention()
		*$s::mouse_registerMovementIntention()
		*$d::mouse_registerMovementIntention()
		*$f::mouse_registerMovementIntention()
		
		*$a::Return ; Slow
		*$'::Return ; Fast

		w::WheelLeft
		r::WheelRight
		y::WheelUp
		h::WheelDown
		z::AppsKey

	   k::LButton
	   l::RButton
	  `;::MButton
	   /::Tab

	#if

; _____________________________________________________________________________/ }}}1

